!*************************************************************************
! This file is part of
!
!       HiggsBounds 2.1.0 (fotran 77 version)
!
! by Philip Bechtle, Oliver Brein, Sven Heinemyer, Georg Weiglein
!    and Karina E. Williams.
!
!  Journal Reference: e-Print: arXiv:0811.4169 [hep-ph], accepted by CPC.
!  Web site: http://www.ippp.dur.ac.uk/HiggsBounds
!
! 2/2/2011
!*************************************************************************


c Definitions of NHMAX, TEV_NSCHN, TEV_NDCHN, LEP_NSCHN, LEP_NDCHN, etc. :
#include "tables-nhmax.F"

#include "input.F"


*************************************************************************
	program HiggsBounds
*************************************************************************
	implicit none
	logical useTEV,useLEP,useSingH,prefix
	character*LENPREFIX fileprefix
	character*5 whichexpt
        character*4 inputmode
	integer i,j,NHIGGS,NHPLUS

	call parse_commandline(NHIGGS,NHPLUS,whichexpt,
     &		inputmode,fileprefix,prefix)

	call calc_HiggsBounds(NHIGGS,NHPLUS,whichexpt,
     &          inputmode,fileprefix,prefix)

	end


*************************************************************************
	subroutine calc_HiggsBounds(NHIGGS,NHPLUS,whichexpt,
     & 		inputmode,fileprefix,prefix)
*************************************************************************
	implicit none
	logical eof,useTEV,useLEP,useSingH,prefix
	logical used_channel(0:LEP_NSneutCHN*NHIGGS+LEP_NScharCHN*NHPLUS
     &		+LEP_NDCHN*NHIGGS**2
     &		+TEV_NSneutCHN*NHIGGS+TEV_NScharCHN*NHPLUS)
	character*LENPREFIX fileprefix
        character*100 FMT
	character*5 whichexpt
	character*4 inputmode
	integer NHIGGS,NHPLUS
	integer id(30),i,j,k,maxid,minid,sanity_flag,l
	integer log2int,output_chan

        integer lineno
        common /current_lineno/ lineno

	integer CP_value(NHMAX)

	double precision Mh(NHMAX),Gamma_h(NHMAX)
	double precision BRhjssbar(NHMAX),BRhjccbar(NHMAX),BRhjbbbar(NHMAX),
     &		BRhjtautau(NHMAX),BRhjWW(NHMAX),BRhjZZ(NHMAX),BRhjZgam(NHMAX),
     &		BRhjgamgam(NHMAX),BRhjgg(NHMAX),
     &		BRhjinvisible(NHMAX),BRhjhihi(NHMAX,NHMAX)

        double precision gs_hjss_sq(NHMAX), gp_hjss_sq(NHMAX),
     &          gs_hjcc_sq(NHMAX), gp_hjcc_sq(NHMAX),
     &		gs_hjbb_sq(NHMAX), gp_hjbb_sq(NHMAX), 
     &          gs_hjtt_sq(NHMAX), gp_hjtt_sq(NHMAX),
     &		gs_hjtautau_sq(NHMAX), gp_hjtautau_sq(NHMAX),
     &		g_hjWW_sq(NHMAX), g_hjZZ_sq(NHMAX), g_hjZgam_sq(NHMAX),
     &          g_hjgamgam_sq(NHMAX), g_hjgg_sq(NHMAX),
     &		g_hjhiZ_sq(NHMAX,NHMAX)

	double precision R_hjZ_ee(NHMAX),
     &		R_bbhj_ee(NHMAX),R_tautauhj_ee(NHMAX),
     &		R_hjhi_ee(NHMAX,NHMAX),
     &		R_hj_gg(NHMAX),R_hj_bb(NHMAX),R_hjb_bg(NHMAX),
     &		R_sigma_H_VBF(NHMAX),
     &		R_hjWp_udb(NHMAX),R_hjWp_csb(NHMAX),R_hjWm_dub(NHMAX),
     &		R_hjWm_scb(NHMAX),
     &		R_hjZ_ddb(NHMAX),R_hjZ_uub(NHMAX),R_hjZ_ssb(NHMAX),
     &		R_hjZ_ccb(NHMAX),R_hjZ_bbb(NHMAX),
     &		R_sigma_ttH(NHMAX)

        double precision R_sigma_H(NHMAX),R_sigma_Hb(NHMAX),
     &		R_sigma_HW(NHMAX),R_sigma_HZ(NHMAX)


        double precision Mhp(NHMAX),Gamma_hp(NHMAX)
        double precision R_HpjHmj_ee(NHMAX)
        double precision BRtWpb,BRtHpjb(NHMAX)
        double precision BRHpjcs(NHMAX),BRHpjcb(NHMAX),BRHpjtaunu(NHMAX)

c>> variables for subroutine calls
	double precision Mh_val(NHIGGS),GammaTot_h(NHIGGS)
	double precision 
     &          g2hjss_s(NHIGGS),g2hjss_p(NHIGGS),
     &          g2hjcc_s(NHIGGS),g2hjcc_p(NHIGGS),
     &		g2hjbb_s(NHIGGS),g2hjbb_p(NHIGGS),
     &		g2hjtt_s(NHIGGS),g2hjtt_p(NHIGGS),
     &		g2hjtautau_s(NHIGGS),g2hjtautau_p(NHIGGS),
     &		g2hjWW(NHIGGS),g2hjZZ(NHIGGS),g2hjZga(NHIGGS),g2hjgaga(NHIGGS),
     &		g2hjgg(NHIGGS),g2hjhiZ(NHIGGS,NHIGGS),
     &		BR_hjinvisible_val(NHIGGS),BR_hjhihi_val(NHIGGS,NHIGGS)

        integer CP_value_val(NHIGGS)
	double precision CS_lep_hjZ_ratio_val(NHIGGS),
     &		CS_lep_bbhj_ratio_val(NHIGGS),
     &		CS_lep_tautauhj_ratio_val(NHIGGS),
     &		CS_lep_hjhi_ratio_val(NHIGGS,NHIGGS),
     &		CS_tev_gg_hj_ratio(NHIGGS),
     &		CS_tev_bb_hj_ratio(NHIGGS), 
     &		CS_tev_bg_hjb_ratio(NHIGGS),
     &		CS_tev_ud_hjWp_ratio(NHIGGS), 
     &		CS_tev_cs_hjWp_ratio(NHIGGS),
     &		CS_tev_ud_hjWm_ratio(NHIGGS), 
     &		CS_tev_cs_hjWm_ratio(NHIGGS),
     &          CS_tev_dd_hjZ_ratio(NHIGGS), 
     &		CS_tev_uu_hjZ_ratio(NHIGGS),
     &		CS_tev_ss_hjZ_ratio(NHIGGS), 
     &		CS_tev_cc_hjZ_ratio(NHIGGS),
     &		CS_tev_bb_hjZ_ratio(NHIGGS),
     &          CS_tev_pp_vbf_ratio_val(NHIGGS),
     &		CS_tev_pp_tthj_ratio_val(NHIGGS),
     &		BR_hjss_val(NHIGGS), BR_hjcc_val(NHIGGS), 
     &		BR_hjbb_val(NHIGGS), BR_hjtautau_val(NHIGGS),
     &		BR_hjWW_val(NHIGGS), BR_hjZZ_val(NHIGGS), BR_hjZga_val(NHIGGS), 
     &		BR_hjgaga_val(NHIGGS), BR_hjgg_val(NHIGGS)

	double precision CS_tev_pp_hj_ratio_val(NHIGGS), 
     &          CS_tev_pp_hjb_ratio_val(NHIGGS),
     &          CS_tev_pp_hjW_ratio_val(NHIGGS), 
     &          CS_tev_pp_hjZ_ratio_val(NHIGGS)

	double precision MHplus_val(NHPLUS),GammaTot_Hp(NHPLUS),
     &          CS_lep_HpjHmj_ratio_val(NHPLUS),
     &		BR_tHpjb_val(NHPLUS),
     &		BR_Hpjcs_val(NHPLUS),BR_Hpjcb_val(NHPLUS),
     &		BR_Hpjtaunu_val(NHPLUS)
c<<


	double precision add_dat(MAX_ADDITIONAL_COLUMNS)
	integer columns

	logical allowed,H_combined(NHMAX)
        integer mlratio,experiment_id,best_result,num_H_combined
        double precision obsratio


	call cmdline_initialize_HiggsBounds(NHIGGS,NHPLUS,whichexpt)

	call determine_topology_flags(whichexpt,
     &          useTEV,useLEP,useSingH)

	do i=0,LEP_NSneutCHN*NHIGGS+LEP_NScharCHN*NHPLUS+LEP_NDCHN*NHIGGS**2
     &		+TEV_NSneutCHN*NHIGGS+TEV_NScharCHN*NHPLUS
	  used_channel(i) = .FALSE.
	enddo

	call initialize_filestatus()
	call open_output_file(30,fileprefix,prefix,NHIGGS,NHPLUS,whichexpt)

	eof = .FALSE.

	do while(eof .eqv. .FALSE.)
	
	k=1

! reading neutral Higgs input (based on inputmode selection):

	  if(NHIGGS .gt. 0) then

	  call read_MH_GammaTot(NHIGGS,fileprefix,prefix,eof,
     &          id(k),Mh,Gamma_h)
	  maxid=id(k)
	  minid=id(k)
	  k=k+1

	  call read_BR_H_NP(NHIGGS,fileprefix,prefix,eof,
     &		id(k),BRhjinvisible,BRhjhihi)
          maxid=max(maxid,id(k))
          minid=min(minid,id(k))
	  k=k+1

	  if(inputmode .eq. 'part') then

	    call read_BR_H_OP(NHIGGS,fileprefix,prefix,eof,
     &		id(k),BRhjssbar,BRhjccbar,BRhjbbbar,BRhjtautau,
     &		BRhjWW,BRhjZZ,BRhjZgam,BRhjgamgam,BRhjgg)
	    maxid=max(maxid,id(k))
            minid=min(minid,id(k))
	    k=k+1

	    call read_CP_values(NHIGGS,fileprefix,prefix,eof,
     &	    id(k),CP_value)
            maxid=max(maxid,id(k))
            minid=min(minid,id(k))
            k=k+1

	    if(useLEP) then 

		call read_LEP_HZ_CS_ratios(NHIGGS,fileprefix,prefix,eof,
     &	            id(k),R_hjZ_ee)
                maxid=max(maxid,id(k))
                minid=min(minid,id(k))
		k=k+1

		call read_LEP_H_ff_CS_ratios(NHIGGS,fileprefix,prefix,eof,
     &		id(k),R_bbhj_ee,R_tautauhj_ee)
                maxid=max(maxid,id(k))
                minid=min(minid,id(k))
		k=k+1

	    	if(.not. useSingH) then
		  call read_LEP_2H_CS_ratios(NHIGGS,fileprefix,prefix,eof,
     &	               id(k),R_hjhi_ee)
                  maxid=max(maxid,id(k))
                  minid=min(minid,id(k))
		  k=k+1
	    	endif
	    endif
	    if(useTEV) then
		call read_TEV_H_0jet_partCS_ratios(NHIGGS,fileprefix,prefix,eof,
     &               id(k),R_hj_gg,R_hj_bb)
                maxid=max(maxid,id(k))
                minid=min(minid,id(k))
		k=k+1

		call read_TEV_H_1jet_partCS_ratios(NHIGGS,fileprefix,prefix,eof,
     &              id(k),R_hjb_bg)
                maxid=max(maxid,id(k))
                minid=min(minid,id(k))
		k=k+1

		call read_TEV_H_vbf_hadCS_ratios(NHIGGS,fileprefix,prefix,eof,
     &              id(k),R_sigma_H_VBF)
                maxid=max(maxid,id(k))
                minid=min(minid,id(k))
		k=k+1

		call read_TEV_HW_partCS_ratios(NHIGGS,fileprefix,prefix,eof,
     &              id(k),R_hjWp_udb,R_hjWp_csb,R_hjWm_dub,R_hjWm_scb)
                maxid=max(maxid,id(k))
                minid=min(minid,id(k))
		k=k+1

		call read_TEV_HZ_partCS_ratios(NHIGGS,fileprefix,prefix,eof,
     &              id(k),R_hjZ_ddb,R_hjZ_uub,R_hjZ_ssb,R_hjZ_ccb,R_hjZ_bbb)
                maxid=max(maxid,id(k))
                minid=min(minid,id(k))
		k=k+1

		call read_TEV_H_tt_hadCS_ratios(NHIGGS,fileprefix,prefix,eof,
     &		id(k),R_sigma_ttH)
                maxid=max(maxid,id(k))
                minid=min(minid,id(k))
		k=k+1
	    endif

	  elseif(inputmode .eq. 'effC') then

	    call read_couplings_sq_ratios(NHIGGS,fileprefix,prefix,eof,
     &          id(k), gs_hjss_sq, gp_hjss_sq,
     &          gs_hjcc_sq, gp_hjcc_sq,
     &		gs_hjbb_sq, gp_hjbb_sq, 
     &          gs_hjtt_sq, gp_hjtt_sq,
     &		gs_hjtautau_sq, gp_hjtautau_sq, 
     &		g_hjWW_sq, g_hjZZ_sq, g_hjZgam_sq,
     &          g_hjgamgam_sq, g_hjgg_sq, g_hjhiZ_sq)
            maxid=max(maxid,id(k))
            minid=min(minid,id(k))
	    k=k+1

!          elseif(inputmode .eq. 'SLHA') then
!c SLHA


	  elseif(inputmode .eq. 'hadr') then

	    call read_BR_H_OP(NHIGGS,fileprefix,prefix,eof,
     &		id(k),BRhjssbar,BRhjccbar,BRhjbbbar,BRhjtautau,
     &		BRhjWW,BRhjZZ,BRhjZgam,BRhjgamgam,BRhjgg)
		maxid=max(maxid,id(k))
                minid=min(minid,id(k))
		k=k+1

	      	call read_CP_values(NHIGGS,fileprefix,prefix,eof,
     &		    id(k),CP_value)
            	maxid=max(maxid,id(k))
            	minid=min(minid,id(k))
            	k=k+1

	    if(useLEP) then 

		call read_LEP_HZ_CS_ratios(NHIGGS,fileprefix,prefix,eof,
     &	            id(k),R_hjZ_ee)
                maxid=max(maxid,id(k))
                minid=min(minid,id(k))
		k=k+1

		call read_LEP_H_ff_CS_ratios(NHIGGS,fileprefix,prefix,eof,
     &		id(k),R_bbhj_ee,R_tautauhj_ee)
                maxid=max(maxid,id(k))
                minid=min(minid,id(k))
		k=k+1
	    endif

	    if(.not. useSingH) then
	      if(useLEP) then
		call read_LEP_2H_CS_ratios(NHIGGS,fileprefix,prefix,eof,
     &	            id(k),R_hjhi_ee)
                maxid=max(maxid,id(k))
                minid=min(minid,id(k))
		k=k+1
	      endif
	    endif

	    if(useTEV) then
		call read_TEV_1H_hadCS_ratios(NHIGGS,fileprefix,prefix,eof,
     &		id(k),R_sigma_H,R_sigma_Hb,R_sigma_HW,R_sigma_HZ,
     &		R_sigma_H_VBF,R_sigma_ttH)
                maxid=max(maxid,id(k))
                minid=min(minid,id(k))
		k=k+1
	    endif
	  endif
	  endif 


! reading charged Higgs input :
! 	presently, no inputmode selection for the charged Higgs input

 	  if(NHPLUS .gt. 0) then

	    call read_MHp_GammaHpTot(NHPLUS,fileprefix,prefix,eof,
     &          id(k),Mhp,Gamma_hp)
	    if(NHIGGS .eq. 0) then
	      maxid=id(k)
	      minid=id(k)
	    else
	      maxid=max(maxid,id(k))
              minid=min(minid,id(k))
	    endif
	    k=k+1
	  
	    call read_BR_Hp(NHPLUS,fileprefix,prefix,eof,
     &		id(k),BRHpjcs,BRHpjcb,BRHpjtaunu)
            maxid=max(maxid,id(k))
            minid=min(minid,id(k))
	    k=k+1

	    call read_BR_t(NHPLUS,fileprefix,prefix,eof,
     &		id(k),BRtWpb,BRtHpjb)
            maxid=max(maxid,id(k))
            minid=min(minid,id(k))
	    k=k+1

	    if(useLEP) then
	      call read_LEP_HpHm_CS_ratios(NHPLUS,fileprefix,prefix,eof,
     &		id(k),R_HpjHmj_ee)
              maxid=max(maxid,id(k))
              minid=min(minid,id(k))
              k=k+1
	    endif

	  endif


! reading additional data

	  call read_additional_data(NHIGGS,fileprefix,prefix,eof,
     &          id(k),add_dat,columns)
! if no columns in file additional.dat id(k) needs to get a value
ccheck	  write(*,*)'columns=',columns
	  if(columns .eq. 0) id(k)=id(1)
	  maxid=max(maxid,id(k))
          minid=min(minid,id(k))

	  if(maxid .ne. minid) then 
	    write(*,*)'maxid=',maxid
	    write(*,*)'minid=',minid
	    write(*,*)'missmatching reference numbers'
	    write(*,*) id
	    stop
	  endif
	

	  lineno=maxid

	  if(.not. eof) then

c	  write(*,*)
c	  write(*,345) id(1)
 345	  FORMAT('###### input line:',I5)

#ifdef VERBOSE
  	  write(*,99) id
 99	  FORMAT ('id=',20I2)

	  write(*,*)'Mh:'
	  call output_vector(NHIGGS,Mh)
	  write(*,*)'Gamma_h:'
	  call output_vector(NHIGGS,Gamma_h)

	  write(*,*)'BRhjinvisible:'
          call output_vector(NHIGGS,BRhjinvisible)
	  if(.not. useSingH) then 
	    write(*,*)'BRhjhihi:'
	    call output_matrix(NHIGGS,BRhjhihi)
	  endif


	  if((inputmode .eq. 'part') .or. (inputmode .eq. 'hadr')) then

	    write(*,*)'BRhjssbar:'
	    call output_vector(NHIGGS,BRhjssbar)
	    write(*,*)'BRhjccbar:'
	    call output_vector(NHIGGS,BRhjccbar)
	    write(*,*)'BRhjbbbar:'
	    call output_vector(NHIGGS,BRhjbbbar)
	    write(*,*)'BRhjtautau:'
	    call output_vector(NHIGGS,BRhjtautau)
	    write(*,*)'BRhjWW:'
	    call output_vector(NHIGGS,BRhjWW)
	    write(*,*)'BRhjZZ'
	    call output_vector(NHIGGS,BRhjZZ)
	    write(*,*)'BRhjZgam:'
	    call output_vector(NHIGGS,BRhjZgam)	
	    write(*,*)'BRhjgamgam:'
	    call output_vector(NHIGGS,BRhjgamgam)	
            if(useLEP) then
	      write(*,*)'R_hjZ_ee:'
              call output_vector(NHIGGS,R_hjZ_ee)
              if(.not. useSingH) then
		write(*,*)'R_hjhi_ee:'
		call output_matrix(NHIGGS,R_hjhi_ee)
	      endif
            endif
          endif

	  if(inputmode .eq. 'effC') then

	  	write(*,*)'gs_hjss_sq:'
	  	call output_vector(NHIGGS,gs_hjss_sq)
	  	write(*,*)'gp_hjss_sq:'
	  	call output_vector(NHIGGS,gp_hjss_sq)
	  	write(*,*)'gs_hjcc_sq:'
	  	call output_vector(NHIGGS,gs_hjcc_sq)
	  	write(*,*)'gp_hjcc_sq:'
	  	call output_vector(NHIGGS,gp_hjcc_sq)
	  	write(*,*)'gs_hjbb_sq:'
	  	call output_vector(NHIGGS,gs_hjbb_sq)
	  	write(*,*)'gp_hjbb_sq:'
	  	call output_vector(NHIGGS,gp_hjbb_sq)
          	write(*,*)'gs_hjtautau_sq:'
          	call output_vector(NHIGGS,gs_hjtautau_sq)
          	write(*,*)'gp_hjtautau_sq:'
          	call output_vector(NHIGGS,gp_hjtautau_sq)
          	write(*,*)'gs_hjtt_sq:'
          	call output_vector(NHIGGS,gs_hjtautau_sq)
          	write(*,*)'gp_hjtt_sq:'
          	call output_vector(NHIGGS,gp_hjtautau_sq)
          	write(*,*)'g_hjWW_sq:'
          	call output_vector(NHIGGS,g_hjWW_sq)
          	write(*,*)'g_hjZZ_sq:'
          	call output_vector(NHIGGS,g_hjZZ_sq)
          	write(*,*)'g_hjZgam_sq:'
          	call output_vector(NHIGGS,g_hjZgam_sq)
          	write(*,*)'g_hjgamgam_sq:'
          	call output_vector(NHIGGS,g_hjgamgam_sq)
          	write(*,*)'g_hjgg_sq:'
          	call output_vector(NHIGGS,g_hjgg_sq)
	  	write(*,*)'g_hjhiZ_sq:'
	  	call output_matrix(NHIGGS,g_hjhiZ_sq)
	  endif

	  if(useTEV) then	  
            if(inputmode .eq. 'part') then
	      write(*,*)'R_hj_gg:'
              call output_vector(NHIGGS,R_hj_gg)
	      write(*,*)'R_hj_bb:'
              call output_vector(NHIGGS,R_hj_bb)
	      write(*,*)'R_hjb_bg:'
              call output_vector(NHIGGS,R_hjb_bg)
	      write(*,*)'R_hjWp_udb:'
              call output_vector(NHIGGS,R_hjWp_udb)
	      write(*,*)'R_hjWp_csb:'
              call output_vector(NHIGGS,R_hjWp_csb)
	      write(*,*)'R_hjWm_dub:'
              call output_vector(NHIGGS,R_hjWm_dub)
	      write(*,*)'R_hjWm_scb:'
              call output_vector(NHIGGS,R_hjWm_scb)
	      write(*,*)'R_hjZ_ddb:'
              call output_vector(NHIGGS,R_hjZ_ddb)
	      write(*,*)'R_hjZ_uub:'
              call output_vector(NHIGGS,R_hjZ_uub)
	      write(*,*)'R_hjZ_ssb:'
              call output_vector(NHIGGS,R_hjZ_ssb)
	      write(*,*)'R_hjZ_ccb:'
              call output_vector(NHIGGS,R_hjZ_ccb)
	      write(*,*)'R_hj:Z_bbb'
              call output_vector(NHIGGS,R_hjZ_bbb)
	      write(*,*)'R_sigma_H_VBF:'
              call output_vector(NHIGGS,R_sigma_H_VBF)
            elseif(inputmode .eq. 'hadr') then
              write(*,*)'R_sigma_H:' 
              call output_vector(NHIGGS,R_sigma_H)
              write(*,*)'R_sigma_Hb:'
              call output_vector(NHIGGS,R_sigma_Hb)
              write(*,*)'R_sigma_HW:'
              call output_vector(NHIGGS,R_sigma_HW)
              write(*,*)'R_sigma_HZ:'
              call output_vector(NHIGGS,R_sigma_HZ)
              write(*,*)'R_sigma_H_VBF:'
              call output_vector(NHIGGS,R_sigma_H_VBF)
	    endif
	  endif
#endif

	if(NHIGGS .ne. 0) then

	  if(inputmode .eq. 'part') then

 	    do i=1,NHIGGS
	      Mh_val(i) 		=Mh(i)
	      GammaTot_h(i)   		=Gamma_h(i)
	      CP_value_val(i)		=CP_value(i)
	      CS_lep_hjZ_ratio_val(i)	=R_hjZ_ee(i)
	      CS_lep_bbhj_ratio_val(i)	=R_bbhj_ee(i)
	      CS_lep_tautauhj_ratio_val(i)=R_tautauhj_ee(i)
	      CS_tev_gg_hj_ratio(i)	=R_hj_gg(i)
	      CS_tev_bb_hj_ratio (i)	=R_hj_bb(i)
	      CS_tev_bg_hjb_ratio(i)	=R_hjb_bg(i)
	      CS_tev_ud_hjWp_ratio(i)	=R_hjWp_udb(i)
	      CS_tev_cs_hjWp_ratio(i)	=R_hjWp_csb(i)
	      CS_tev_ud_hjWm_ratio(i)	=R_hjWm_dub(i)
	      CS_tev_cs_hjWm_ratio(i)	=R_hjWm_scb(i)
	      CS_tev_dd_hjZ_ratio(i)	=R_hjZ_ddb(i)
	      CS_tev_uu_hjZ_ratio(i)	=R_hjZ_uub(i)
	      CS_tev_ss_hjZ_ratio(i)	=R_hjZ_ssb(i)
	      CS_tev_cc_hjZ_ratio(i)	=R_hjZ_ccb(i)
	      CS_tev_bb_hjZ_ratio(i)	=R_hjZ_bbb(i)
	      CS_tev_pp_vbf_ratio_val(i)=R_sigma_H_VBF(i)
	      CS_tev_pp_tthj_ratio_val(i)=R_sigma_ttH(i)
	      BR_hjss_val(i)		=BRhjssbar(i)
	      BR_hjcc_val(i)		=BRhjccbar(i)
	      BR_hjbb_val(i)		=BRhjbbbar(i)
	      BR_hjtautau_val(i)	=BRhjtautau(i)
	      BR_hjWW_val(i)		=BRhjWW(i)
	      BR_hjZZ_val(i)		=BRhjZZ(i)
	      BR_hjZga_val(i)		=BRhjZgam(i)
	      BR_hjgaga_val(i)		=BRhjgamgam(i)
	      BR_hjgg_val(i)		=BRhjgg(i)
	      BR_hjinvisible_val(i)	=BRhjinvisible(i)
	      do j=1,NHIGGS
	        CS_lep_hjhi_ratio_val(i,j)=R_hjhi_ee(i,j)
	        BR_hjhihi_val(i,j)	  =BRhjhihi(i,j)
	      enddo
	    enddo
	
	    call HiggsBounds_neutral_input_part(Mh_val, GammaTot_h,
     &		CP_value_val,
     &		CS_lep_hjZ_ratio_val,
     &		CS_lep_bbhj_ratio_val,
     &		CS_lep_tautauhj_ratio_val,
     &		CS_lep_hjhi_ratio_val,
     &		CS_tev_gg_hj_ratio,
     &		CS_tev_bb_hj_ratio, 
     &		CS_tev_bg_hjb_ratio,
     &		CS_tev_ud_hjWp_ratio, CS_tev_cs_hjWp_ratio,
     &		CS_tev_ud_hjWm_ratio, CS_tev_cs_hjWm_ratio,
     &          CS_tev_dd_hjZ_ratio, CS_tev_uu_hjZ_ratio,
     &		CS_tev_ss_hjZ_ratio, CS_tev_cc_hjZ_ratio,
     &		CS_tev_bb_hjZ_ratio,
     &          CS_tev_pp_vbf_ratio_val,
     &		CS_tev_pp_tthj_ratio_val,
     &		BR_hjss_val, BR_hjcc_val, BR_hjbb_val, BR_hjtautau_val,
     &		BR_hjWW_val, BR_hjZZ_val, BR_hjZga_val, BR_hjgaga_val, BR_hjgg_val,
     & 		BR_hjinvisible_val, BR_hjhihi_val)

	  elseif(inputmode .eq. 'effC') then

c>> check
c	write(*,*)'before:'
c	do i=1,NHIGGS
c	write(*,*)'g_hjhiZ_sq(',i,',j)=',(g_hjhiZ_sq(i,j),j=1,NHIGGS)
c	enddo
c	do i=1,NHIGGS
c	write(*,*)'BRhjhihi(',i,',j)=',(BRhjhihi(i,j),j=1,NHIGGS)
c	enddo
c<<
	do i=1,NHIGGS
	Mh_val(i)	=Mh(i)
	GammaTot_h(i)	=Gamma_h(i)
     	g2hjss_s(i)	=gs_hjss_sq(i)
	g2hjss_p(i)	=gp_hjss_sq(i)
     	g2hjcc_s(i)	=gs_hjcc_sq(i)
	g2hjcc_p(i)	=gp_hjcc_sq(i)
     	g2hjbb_s(i)	=gs_hjbb_sq(i)
	g2hjbb_p(i)	=gp_hjbb_sq(i)
     	g2hjtt_s(i)	=gs_hjtt_sq(i)
	g2hjtt_p(i)	=gp_hjtt_sq(i)
	g2hjtautau_s(i)	=gs_hjtautau_sq(i)
	g2hjtautau_p(i)	=gp_hjtautau_sq(i)
     	g2hjWW(i)	=g_hjWW_sq(i)
	g2hjZZ(i)	=g_hjZZ_sq(i)
	g2hjZga(i)	=g_hjZgam_sq(i)
	g2hjgaga(i)	=g_hjgamgam_sq(i)
     	g2hjgg(i)	=g_hjgg_sq(i)
     	BR_hjinvisible_val(i)=BRhjinvisible(i)
        do j=1,NHIGGS  	
	g2hjhiZ(i,j)	=g_hjhiZ_sq(i,j)
	BR_hjhihi_val(i,j)=BRhjhihi(i,j)
	enddo
	enddo

	    call HiggsBounds_neutral_input_effC(Mh_val,GammaTot_h,
     & g2hjss_s,g2hjss_p,g2hjcc_s,g2hjcc_p,g2hjbb_s,g2hjbb_p,
     & g2hjtt_s,g2hjtt_p,g2hjtautau_s,g2hjtautau_p,
     & g2hjWW,g2hjZZ,g2hjZga,g2hjgaga,g2hjgg,
     & g2hjhiZ, BR_hjinvisible_val,BR_hjhihi_val)

	  elseif(inputmode .eq. 'hadr') then

c>> check
c	write(*,*)'before:'
c	do i=1,NHIGGS
c	write(*,*)'R_hjhi_ee(',i,',j)=',(R_hjhi_ee(i,j),j=1,NHIGGS)
c	enddo
c	do i=1,NHIGGS
c	write(*,*)'BRhjhihi(',i,',j)=',(BRhjhihi(i,j),j=1,NHIGGS)
c	enddo
c<<


	    do i=1,NHIGGS
              Mh_val(i)			=Mh(i)
	      GammaTot_h(i)   		=Gamma_h(i)
              CP_value_val(i)		=CP_value(i)
              CS_lep_hjZ_ratio_val(i)	=R_hjZ_ee(i)
              CS_lep_bbhj_ratio_val(i)	=R_bbhj_ee(i)
              CS_lep_tautauhj_ratio_val(i)=R_tautauhj_ee(i)
              CS_tev_pp_hj_ratio_val(i)	=R_sigma_H(i) 
              CS_tev_pp_hjb_ratio_val(i)=R_sigma_Hb(i)
              CS_tev_pp_hjW_ratio_val(i)=R_sigma_HW(i) 
              CS_tev_pp_hjZ_ratio_val(i)=R_sigma_HZ(i)
              CS_tev_pp_vbf_ratio_val(i)=R_sigma_H_VBF(i)
              CS_tev_pp_tthj_ratio_val(i)=R_sigma_ttH(i)
              BR_hjss_val(i)		=BRhjssbar(i)
              BR_hjcc_val(i)		=BRhjccbar(i)
              BR_hjbb_val(i)		=BRhjbbbar(i)
              BR_hjtautau_val(i)	=BRhjtautau(i)
              BR_hjWW_val(i)		=BRhjWW(i)
              BR_hjZZ_val(i)		=BRhjZZ(i)
              BR_hjZga_val(i)		=BRhjZgam(i)
              BR_hjgaga_val(i)		=BRhjgamgam(i)
              BR_hjgg_val(i)		=BRhjgg(i)
              BR_hjinvisible_val(i)	=BRhjinvisible(i)
	      do j=1,NHIGGS
                CS_lep_hjhi_ratio_val(i,j)=R_hjhi_ee(i,j)
                BR_hjhihi_val(i,j)	  =BRhjhihi(i,j)
	      enddo
	    enddo

	    call HiggsBounds_neutral_input_hadr(Mh_val, GammaTot_h,
     &		CP_value_val,
     &          CS_lep_hjZ_ratio_val,
     &          CS_lep_bbhj_ratio_val,
     &          CS_lep_tautauhj_ratio_val,
     &          CS_lep_hjhi_ratio_val,
     &          CS_tev_pp_hj_ratio_val, 
     &          CS_tev_pp_hjb_ratio_val,
     &          CS_tev_pp_hjW_ratio_val, 
     &          CS_tev_pp_hjZ_ratio_val,
     &          CS_tev_pp_vbf_ratio_val,
     &          CS_tev_pp_tthj_ratio_val,
     &          BR_hjss_val, BR_hjcc_val, BR_hjbb_val, BR_hjtautau_val, 
     &          BR_hjWW_val, BR_hjZZ_val, BR_hjZga_val, BR_hjgaga_val, BR_hjgg_val,
     &          BR_hjinvisible_val, BR_hjhihi_val)


	  endif
	endif

	if(NHPLUS .ne. 0) then

	  do i=1,NHPLUS
              MHplus_val(i)=Mhp(i)
              GammaTot_Hp(i)=Gamma_hp(i)
              CS_lep_HpjHmj_ratio_val(i)=R_HpjHmj_ee(i)
              BR_tHpjb_val(i)=BRtHpjb(i)
              BR_Hpjcs_val(i)=BRHpjcs(i)
              BR_Hpjcb_val(i)=BRHpjcb(i)
              BR_Hpjtaunu_val(i)=BRHpjtaunu(i)
	  enddo

c remark: BRtWpb is not an array. So, no conversion needed.

          call HiggsBounds_charged_input(MHplus_val,GammaTot_Hp,
     &		CS_lep_HpjHmj_ratio_val,BRtWpb,
     &		BR_tHpjb_val,BR_Hpjcs_val,BR_Hpjcb_val,BR_Hpjtaunu_val)

	
	endif


	call run_HiggsBounds(best_result,output_chan,obsratio,num_H_combined)

	used_channel(output_chan) = .TRUE.

#ifdef G77VERSION 
	if(columns .gt. 0) then
c the case NHIGGS=NHPLUS=0 doesn't occur here (is trapped before)
	  if((NHIGGS .gt. 0) .and. (NHPLUS .gt. 0)) then
	    write(FMT,'("(I7,",I0," G16.6,",I0," G16.6,I5,I5,G16.6,I5,",I0," G16.6)")') NHIGGS,NHPLUS,columns
            write(30,FMT) id(1),(Mh(i),i=1,NHIGGS),(Mhp(i),i=1,NHPLUS),
     &		best_result,output_chan,obsratio,num_H_combined,
     &		(add_dat(j),j=1,columns)
	  elseif(NHIGGS .eq. 0) then	
	    write(FMT,'("(I7,",I0," G16.6,I5,I5,G16.6,I5,",I0," G16.6)")') NHPLUS,columns
            write(30,FMT) id(1),(Mhp(i),i=1,NHPLUS),
     &		best_result,output_chan,obsratio,num_H_combined,
     &		(add_dat(j),j=1,columns)
	  elseif(NHPLUS .eq. 0)	 then
	    write(FMT,'("(I7,",I0," G16.6,I5,I5,G16.6,I5,",I0," G16.6)")') NHIGGS,columns
            write(30,FMT) id(1),(Mh(i),i=1,NHIGGS),
     &		best_result,output_chan,obsratio,num_H_combined,
     &		(add_dat(j),j=1,columns)
	  endif
	elseif(columns .eq. 0) then
          if((NHIGGS .gt. 0) .and. (NHPLUS .gt. 0)) then
	    write(FMT,'("(I7,",I0," G16.6,",I0," G16.6,I5,I5,G16.6,I5)")') NHIGGS,NHPLUS
            write(30,FMT) id(1),(Mh(i),i=1,NHIGGS),(Mhp(i),i=1,NHPLUS),
     &		best_result,output_chan,obsratio,num_H_combined
          elseif(NHIGGS .eq. 0) then    
	    write(FMT,'("(I7,",I0," G16.6,I5,I5,G16.6,I5)")') NHPLUS
            write(30,FMT) id(1),(Mhp(i),i=1,NHPLUS),
     &		best_result,output_chan,obsratio,num_H_combined
          elseif(NHPLUS .eq. 0)  then   
	    write(FMT,'("(I7,",I0," G16.6,",I0," G16.6,I5,I5,G16.6,I5)")') NHIGGS
            write(30,FMT) id(1),(Mh(i),i=1,NHIGGS),
     &		best_result,output_chan,obsratio,num_H_combined
          endif
	endif

#else
	write(30,455) id(1),(Mh(i),i=1,NHIGGS),(Mhp(i),i=1,NHPLUS),
     &		best_result,output_chan,obsratio,num_H_combined,
     &		(add_dat(j),j=1,columns)
!,(log2int(H_combined(i)),i=1,NHIGGS)
 455	FORMAT (I7,<NHIGGS>G16.6,<NHPLUS>G16.6,I5,I5,G16.6,I5,<columns>G16.6)
! 455	FORMAT (I7,<NHIGGS>G16.6,<NHPLUS>G16.6,I5,I5,G16.6,I5,' ',<NHIGGS>I2)
#endif
	endif

	enddo

c write legend

	write(30,*)'# channel numbers used in this file'
	do i=0,LEP_NSneutCHN*NHIGGS+LEP_NScharCHN*NHPLUS+LEP_NDCHN*NHIGGS**2
     &		+TEV_NSneutCHN*NHIGGS+TEV_NScharCHN*NHPLUS
	  if(used_channel(i)) 
     &        call write_output_channel(30,NHIGGS,NHPLUS,whichexpt,i)
	enddo
		
	close(30)

	end



*****************************************************************************
	subroutine parse_commandline(NHIGGS,NHPLUS,whichexpt,
     &           inputmode,fileprefix,prefix)
*****************************************************************************
	implicit none 

	integer iargc, lnblnk
!        external iargc, lnblnk

	integer narg,i
	character*LENPREFIX barearg,arg(5)
        character*5 whichexpt
	character*4 inputmode
	
	integer NHIGGS,NHPLUS
	logical prefix
	character*LENPREFIX fileprefix

	narg = iargc()
	
ccheck	write(*,*)'narg=',narg

	if((narg .lt. 4) .or. (narg .gt. 5)) goto 100


	do i=1,narg,1
	  call getarg(i, barearg)
          arg(i)=barearg(:lnblnk(barearg))
	enddo



	if(arg(1). eq. 'onlyT') then
		whichexpt=arg(1)
	elseif(arg(1). eq. 'onlyL') then
		whichexpt=arg(1)
	elseif(arg(1). eq. 'LandT') then
		whichexpt=arg(1)
	elseif(arg(1). eq. 'singH') then
		whichexpt=arg(1)
	elseif(arg(1). eq. 'onlyP') then
		whichexpt=arg(1)
	else
		goto 100
	endif
	
	if(arg(2) .eq. 'part') then
		inputmode=arg(2)
	elseif(arg(2) .eq. 'effC') then
		inputmode=arg(2)
!	elseif(arg(2) .eq. 'SLHA') then
!		inputmode=arg(2)
	elseif(arg(2) .eq. 'hadr') then
		inputmode=arg(2)
	else
		goto 100
	endif



#ifdef G77VERSION
	read(arg(3),'(I20)',err=100) NHIGGS
#else
	read(arg(3),'(I)',err=100) NHIGGS
#endif
	if((NHIGGS .lt. 0) .or. (NHIGGS .gt. NHMAX)) goto 100


#ifdef G77VERSION
	read(arg(4),'(I20)',err=100) NHPLUS
#else
	read(arg(4),'(I)',err=100) NHPLUS
#endif
	if((NHPLUS .lt. 0) .or. (NHPLUS .gt. NHMAX)) goto 100
	
	if(NHPLUS+NHIGGS .lt. 1) goto 100


	
	if(narg .eq. 4) then
		fileprefix='                    '
		prefix=.FALSE.
	else
		fileprefix=arg(5)
                prefix=.TRUE.
	endif



	return
	
 100 	continue

c>> check
c	do i=1,narg
c	  write(*,*)'arg(',i,')=',arg(i)
c	enddo
c        write(*,*)'NHIGGS=',NHIGGS
c	write(*,*)'inputmode=',inputmode
c	write(*,*)'fileprefix=',fileprefix
c        write(*,*)'prefix=',prefix
c<<

	call write_HiggsBounds_info()

	write(*,*)'wrong input  !'
	write(*,*)'HiggsBounds usage :'
	write(*,*)'  HiggsBounds <analyses> <input mode> <nHzero> <nHplus> [<fileprefix>]'
	write(*,*)'with'
	write(*,*)'     <analyses>   : LandT (LEP and Tevatron analyses)'
	write(*,*)'                  : onlyT (only Tevatron analyses)'
	write(*,*)'                  : onlyL (only LEP analyses)'
	write(*,*)'                  : singH (only single Higgs analyses)'
	write(*,*)'     <input mode> : part (BRs and CS ratios (partonic CS ratios for Tevatron))'
	write(*,*)'                  : hadr (BRs and CS ratios (hadronic CS ratios for Tevatron))'
	write(*,*)'                  : effC (effective couplings)'	
!	write(*,*)'                  : SLHA (SLHA format input)'
	write(*,*)'     <nHzero>     : 1 to 10 (number of neutral Higgs bosons)'
	write(*,*)'     <nHplus>     : 1 to 10 (number of charged Higgs bosons)'
	write(*,*)'     <fileprefix> : prefix for input files (optional,'
	write(*,*)'                           can also be a subdirectory)'

	stop

	end




*****************************************************************************
        subroutine open_output_file(
     &		file_id,fileprefix,prefix,NHIGGS,NHPLUS,whichexpt)
*****************************************************************************
        implicit none

        integer iargc, lnblnk
!        external iargc, lnblnk

        integer narg,i,file_id,NHIGGS,NHPLUS
        character*100 FMT
	character*5 whichexpt
	character*9 ws
	character*4 bl
        logical prefix
        character*LENPREFIX fileprefix,barearg,arg(5)

	if(prefix) then
	  open(file_id,file=fileprefix(:lnblnk(fileprefix))//'HiggsBounds_results.dat')
	  open(file_id+1,file=fileprefix(:lnblnk(fileprefix))//'Key.dat')
	else
	  open(file_id,file='HiggsBounds_results.dat')
	  open(file_id+1,file='Key.dat')
	endif

	call write_table_key(file_id+1,NHIGGS,NHPLUS,whichexpt)

	close(file_id+1)

        narg = iargc()
	do i=1,narg,1
          call getarg(i, barearg)
          arg(i)=barearg(:lnblnk(barearg))
        enddo
	
        write(file_id,*)'# File generated with HiggsBounds 2.0.0 (FORTRAN77 version)'
	write(file_id,*)'# HiggsBounds command used:'
	write(file_id,*)'#   HiggsBounds ',(arg(i)(:lnblnk(arg(i)))//' ',i=1,narg)
        write(file_id,*)'#'
	write(file_id,300) NHIGGS
 300	FORMAT(' #     number of neutral Higgs bosons: ',I2)
	write(file_id,301) ,NHPLUS
 301	FORMAT(' #     number of charged Higgs bosons: ',I2)
        write(file_id,*)'#'
	write(file_id,*)'# column description:'
	write(file_id,*)'#   0 : line id of input'
	if(NHIGGS .gt. 0) then
	  write(file_id,459) NHIGGS
 459	  FORMAT(' #   i : neutral Higgs boson masses Mh(i) (i=1,...,',I2,')')
	endif
        if(NHPLUS .gt. 0) then
          write(file_id,4591) NHIGGS+1,NHIGGS+NHPLUS
 4591	  FORMAT(' #   j : charged Higgs boson masses MHplus(j) (j=',I2,',...,',I2,')')
	endif
	write(file_id,460) NHIGGS+NHPLUS+1
 460	FORMAT(' # ',I3,' : scenario allowed flag (1: allowed, 0: excluded, -1: unphysical)')
	write(file_id,461) NHIGGS+NHPLUS+2
 461	FORMAT(' # ',I3,' : most sensitive channel (see files: Key_LEP-tables, Key_TEV-tables)')
!	write(file_id,462) NHIGGS+NHPLUS+3
! 462	FORMAT(' # ',I3,' : experiment with best channel (1: LEP, 2: Tevatron)')
	write(file_id,463) NHIGGS+NHPLUS+3
 463	FORMAT(' # ',I3,' : ratio [sig x BR]_model/[sig x BR]_limit (<1: allowed, >1: excluded)')
	write(file_id,464) NHIGGS+NHPLUS+4
 464	FORMAT(' # ',I3,' : number of Higgs bosons combined in most sensitive channel')
	write(file_id,*)'# columns :'
#ifdef G77VERSION

	write(FMT,*) NHIGGS+NHPLUS
	write(file_id,"(' #',I5," // ADJUSTL(FMT) // "(I9,'       '),I5,I5,I9,'       ',I5)") (i,i=0,4+NHIGGS+NHPLUS)

#else
	write(file_id,457) (i,i=0,4+NHIGGS+NHPLUS)
 457	FORMAT (' #',I5,<NHIGGS+NHPLUS>(I9,'       '),I5,I5,I9,'       ',I5)
#endif
        write(file_id,*)'#'


	end

*********************************************************************
        subroutine cmdline_initialize_HiggsBounds(NHIGGS_val,NHPLUS_val,whichexpt_val)
*********************************************************************
        implicit none
#include "input_cb.h"

        integer NHIGGS_val,NHPLUS_val
	character*5 whichexpt_val

	CMDLINE = .TRUE.

	NHIGGS=NHIGGS_val
	NHPLUS=NHPLUS_val
	whichexpt=whichexpt_val

	call write_HiggsBounds_info()

        call initialize_SM_decay_data()
        call initialize_TEV_tables()
        call initialize_LEP_tables()

	open(87,file='Key.dat')
	call write_table_key(87,NHIGGS_val,NHPLUS_val,whichexpt_val)
	close(87)

        end



