!*************************************************************************
! This file is part of
!
!       HiggsBounds 2.1.0 (fotran 77 version)
!
! by Philip Bechtle, Oliver Brein, Sven Heinemyer, Georg Weiglein
!    and Karina E. Williams.
!
!  Journal Reference: e-Print: arXiv:0811.4169 [hep-ph], accepted by CPC.
!  Web site: http://www.ippp.dur.ac.uk/HiggsBounds
!
! 2/2/2011
!*************************************************************************


!>>
!#define VERBOSE
!#define DEBUG
!<<


!maximum number of Higgs bosons
#define NHMAX 10

!maximum number of additional data columns in 'additional.dat'
#define MAX_ADDITIONAL_COLUMNS 20

!maximum character length of prefix string
#define LENPREFIX 300

#define LEP_NSneutCHN 17
#define LEP_NScharCHN 6
#define LEP_NDCHN 9
#define LEP_NSCHN (LEP_NSneutCHN+LEP_NScharCHN)

! suggested values : delta_Mh_LEP < 2d0
#define delta_Mh_LEP 0d0
c deactivated #define delta_Mhplus_LEP 2d0

#define TEV_NSneutCHN 51
#define TEV_NScharCHN 4
#define TEV_NDCHN 0
#define TEV_NSCHN (TEV_NSneutCHN+TEV_NScharCHN)

! suggested values : delta_Mh_TEV < 10d0
#define delta_Mh_TEV 0d0
c deactivated #define delta_Mhplus_TEV 10d0

!maximum numbers of Analyses
#define MAX_LEP1d_ANALYSES (LEP_NSneutCHN+LEP_NScharCHN)
#define MAX_LEP2d_ANALYSES (LEP_NDCHN)
#define MAX_TEV1d_ANALYSES (TEV_NSneutCHN+TEV_NScharCHN) 
#define MAX_TEV2d_ANALYSES (TEV_NDCHN)

!maximum numbers of lines per analysis
! adjust if tables of new analyses have more lines of data
#define MAX_LEP1d_LINES 1087
#define MAX_LEP2d_LINES 200
#define MAX_TEV1d_LINES 40

! Value of variable eps in subroutine check_TEV_applicability
! Suggested default value: 0.02
#define EPS_SM_LIKENESS 0.02d0


! LEP table identifiers: 

! single neutral Higgs analyses
#define LEPhZ_bbZ	
#define LEPhZ_tautauZ	
#define LEPhZ_anyZ	
#define LEPhZ_invisZ    
#define LEPhZ_gamgamZ	
#define LEPhZ_jjZ       
#define DELPHIbbh_4b	
#define DELPHIbba_4b	
#define DELPHIbbh_2b2tau	
#define OPALbbh_2b2tau	
! 10
#define DELPHIbba_2b2tau	
#define OPALbba_2b2tau	
#define DELPHItautauh_4tau	
#define DELPHItautaua_4tau 
#define DELPHIhZ_invisZ 
! 15
#define L3hZ_invisZ   	
#define OPALhZ_invisZ   



! single charged Higgs analyses
c temporarily removed #define OPALhphm_2tau2nu 
c temporarily removed #define OPALhphm_2jtaunu 
c temporarily removed #define OPALhphm_4j	
#define LEPhphm_4j	
#define DELPHIhphm_4j	
!  5
#define DELPHIhphm_2tau2nu 


! double neutral Higgs analyses
#define LEPh2Z_h1h1Z_4bZ	
#define LEPh2Z_h1h1Z_4tauZ 	
#define LEPh2h1_4b		
#define LEPh2h1_4tau		
#define LEPh2h1_h1h1h1_6b	
! 5
#define LEPh2h1_h1h1h1_6tau	
c temporarily removed #define LEPh2Z_h1h1Z_2b2tau	
#define LEPh2h1_2b2tau		
#define LEPh2h1_2tau2b



! Tevatron table identifiers:
! single neutral Higgs analyses
#define CDF1009_3047  	
#define CDF10235 	
#define CDF10212 	
#define D06089		
#define D06087		
#define CDF8961_D05536 	
#define CDF10105	
#define D06092		
#define CDF10239	
#define D05726		
! 10
#define D01011_1931	
#define D00805_2491	
#define CDF0906_1014	
#define D05873		
#define CDF7307v3	
#define D05858		
#define CDF10133		
#define CDF9290_D05645	
#define D05757		
#define CDF0809_3930 	
! 20
#define CDF9465_D05754	
#define CDF10102	
#define D05871		
#define D01012_0874     
#define CDF0906_5613	
#define D00912_0968	
#define D05740		
#define D00912_5285	
#define CDF0911_3935	
#define D00901_1887	
! 30
#define D00712_0598	
#define CDF10099_D06063	
#define D05985  	
#define CDF9999         
#define D05739		
#define D00806_0611 	
#define D01001_4481	
#define D00903_4800	
#define D05845		
#define D06008		
! 40
#define CDF9998_D05983	
#define CDF10065	
#define CDF10010	
#define CDF1001_4468	
#define CDF_D0_1001_4162
#define CDF_D0_1005_3216
#define D06082
#define D06091		
c deactivated #define D06083abslim  	
#define D06083
#define CDF10241_D06096
! 50
!temporary removed #define D00803_1514
#define D01008_3564

! single charged Higgs analyses
#define D00908_1811cs		
#define D00908_1811taunu	
#define CDF0907_1269low		
#define CDF0907_1269hi		



